# utPLSQL .NET API
.NET API for running utPLSQL v3+ unit tests from .NET applications

## Usage

### Run Tests and Consume Results

    var testRunner = new RealTimeTestRunner();
    testRunner.Connect(username: "toscamtest", password: "toscamtest", database: "CA40");

    // Runs tests for the user tosamtest
    var events = new List<@event>();

    await testRunner.RunTestsAsync("toscamtest", @event =>
    {
        events.Add(@event);
    });

### Get Coverage Report

    var testRunner = new RealTimeTestRunner();
    testRunner.Connect(username: "toscamtest", password: "toscamtest", database: "CA40");

    var events = new List<@event>();

    string htmlReport = await testRunner.RunTestsWithCoverageAsync(path: "toscamtest", 
                                             consumer: @event => { events.Add(@event); },
                                             coverageSchema: "toscam", 
                                             includeObjects: new List<string>() { "pa_m720", "pa_m770" });

## Releases

Releases are published to nuGet: https://www.nuget.org/packages/utPLSQL.Api/

## Issues

Please file your bug reports, enhancement requests, questions and other support requests within [Github's issue tracker](https://help.github.com/articles/about-issues/).

* [Questions](https://github.com/utPLSQL/utPLSQL-dotnet-api/issues?q=is%3Aissue+label%3Aquestion)
* [Open enhancements](https://github.com/utPLSQL/utPLSQL-dotnet-api/issues?q=is%3Aopen+is%3Aissue+label%3Aenhancement)
* [Open bugs](https://github.com/utPLSQL/utPLSQL-dotnet-api/issues?q=is%3Aopen+is%3Aissue+label%3Abug)
* [Submit new issue](https://github.com/utPLSQL/utPLSQL-dotnet-api/issues/new)

## How to Contribute

1. Describe your idea by [submitting an issue](https://github.com/utPLSQL/utPLSQL-dotnet-api/issues/new)
2. [Fork the utPLSQL-PLSQL-Developer respository](https://github.com/utPLSQL/utPLSQL-dotnet-api/fork)
3. [Create a branch](https://help.github.com/articles/creating-and-deleting-branches-within-your-repository/), commit and publish your changes and enhancements
4. [Create a pull request](https://help.github.com/articles/creating-a-pull-request/)

## How to Build

1. Open the utPLSQL.Api.sln solution in Visual Studio
2. Build the solution

## License

utPLSQL .NET API is licensed under the Apache License, Version 2.0.
You may obtain a copy of the License at <http://www.apache.org/licenses/LICENSE-2.0>.


